//
//  ViewController.swift
//  Wonderrfy
//
//  Created by Azad on 10/04/2016.
//  Copyright © 2016 Brainload Technologies. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    
    @IBOutlet weak var backButton: UIBarButtonItem!
    @IBOutlet weak var webView: UIWebView!
    @IBOutlet weak var activityIndicator: UIActivityIndicatorView!
    
    var checkInternetconnection = true
    
    
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view, typically from a nib.
        
        
        //backButton hiding and disabling
        self.backButton.tintColor = UIColor.clearColor()
        backButton.enabled = webView.canGoBack
        
        
        
        
        //You can change website url here
        //webpage link
        let link = "http://demo.wowonder.com/welcome"
        
        
        //webpage Load
        let url = NSURL(string: link)
        let requestObj = NSURLRequest(URL: url!);
        webView.loadRequest(requestObj)
        
        //for refreshing webpage by pull down
        let refreshControl: UIRefreshControl = UIRefreshControl()
        refreshControl.addTarget(self, action: #selector(ViewController.handleRefresh(_:)), forControlEvents:.ValueChanged)
        webView.scrollView.addSubview(refreshControl)
        
        //for showing splash screen 1 second more
        NSThread.sleepForTimeInterval(1)
        
        
        
        
        NSNotificationCenter.defaultCenter().addObserver(self, selector: #selector(ViewController.receivedDataNotification(_:)), name: "ReceivedData", object: nil)
        
    }
  
    
    func webViewDidStartLoad(_ : UIWebView)
    {
        backButtonHiding()
        activityIndicator.startAnimating()
        
        if checkInternetconnection
        {
            
        
        Reachability.isConnectedToNetwork()
         
        }
      checkInternetconnection = false
    }

    
    func receivedDataNotification(object: AnyObject) {
        showAlert("No Internet Connection")
    }
    
    func webViewDidFinishLoad(_ : UIWebView)
    {
        
        backButton.enabled = webView.canGoBack
        backButtonHiding()
        
        activityIndicator.stopAnimating()
        checkInternetconnection = true
    }
    
    
    @IBAction func backAction(sender: UIBarButtonItem) {
        
        webView.goBack()
        
    }
    
    
    
    func handleRefresh(refresh: UIRefreshControl) {
        
        // Reload web page
        activityIndicator.stopAnimating()
        webView.reload()
       // activityIndicator.startAnimating()
        if checkInternetconnection
        {
        Reachability.isConnectedToNetwork()
        
         }
        checkInternetconnection = false
         refresh.endRefreshing()
       
    }
    
    
    func webView(webView: UIWebView, didFailLoadWithError error: NSError?) {
        UIApplication.sharedApplication().networkActivityIndicatorVisible = false
    }
    
    
    //hide button when webpage can not go back
    func backButtonHiding()
    {
        if !webView.canGoBack
        {
            self.backButton.tintColor = UIColor.clearColor()
        }
        else
        {
            self.backButton.tintColor = UIColor.whiteColor()
        }
    }
    
    
    
    
    func showAlert(ErrMSG : String) {
        // Initialize Alert Controller
        let alertController = UIAlertController(title: "Alert", message: ErrMSG, preferredStyle: .Alert)
        
        // Initialize Actions
        let yesAction = UIAlertAction(title: "Reload", style: .Default) { (action) -> Void in
            self.activityIndicator.stopAnimating()
            self.webView.reload()
            self.activityIndicator.startAnimating()
            
            Reachability.isConnectedToNetwork()
          
        }
        
        
        
        // Add Actions
        alertController.addAction(yesAction)
        
        
        // Present Alert Controller
        self.presentViewController(alertController, animated: true, completion: nil)
    }
    
    
    
    
}

